/*******************************************************************************
 *	@file			TestDXLibv2.cpp
 *	@brief			DirectX Test Program
 *
 *	@date			08-Apr-2009(Wed)
 ******************************************************************************/

// vvZbT---------------------------------------------------------------
#include "DL.h"
#include "DLGraph.h"
#include "DLSound.h"

#pragma comment ( lib, "_DXLibv2.lib" )

// 񋓌^`-------------------------------------------------------------------
/*******************************************************************************
 *	@enum		enumDisplay
 *	@brief		ʃTCY
 ******************************************************************************/
enum enumDisplay
{
	enumDisplay_640x480		= 0,												//!<  VGA( 640x 480)
	enumDisplay_800x600,														//!< SVGA( 800x 600)
	enumDisplay_1024x768,														//!<  XGA(1024x 768)
	enumDisplay_FullScreen,														//!< tXN[

	enumDisplay_Max,
};

// O[oϐ---------------------------------------------------------
static const char* const APPNAME	= "TESTDXLIBV2";							//!< Av̖O
static const int APPWIDTH			= 800;										//!< Av̏
static const int APPHEIGHT			= 600;										//!< Av̏
static const float FRAMERATE		= 33.33333333333f;							//!< t[[g

HANDLE	g_hMutex = NULL;														//!< Lnh
HWND	g_hWnd = NULL;															//!< EChEnh

DL::SDLParam g_SDL;																//!< p[^
enumDisplay g_eDisp = enumDisplay_800x600;										//!< \

DWORD	g_dwTimer[ 3 ];															//!< v^C}[
float	g_fDiffTime = 0.0f;														//!< ^C}[

static const int OBJMAX				= 128;
static const int DBGMAX				= 16;
DL::SDLGraph g_SObj[ OBJMAX + DBGMAX ];											//!< IuWFNg

static const int METERMAX			= 4;
static const int STRMAX				= 8;

DL::SDLMaterial g_SDebugFont;
DL::SDLDebug g_SDbg;															//!< fobO
float	g_fMeter[ 2 ];															//!< v[^[

float	g_fMinFps = FRAMERATE;													//!< vŏl
float	g_fMaxFps = 0.0f;														//!< vől
float	g_fAveFps = 0.0f;														//!< vϒl
int		g_nFrameCnt = 0;														//!< vt[

char	g_cMinFps[ 256 ];
char	g_cMaxFps[ 256 ];
char	g_cAveFps[ 256 ];

// ֐vg^Cv錾---------------------------------------------------

// -----------------------------------------------------------------------------
/*******************************************************************************
 *	@fn				LRESULT CALLBACK WndProc( HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam )
 *	@retval			LRESULT
 *	@brief			EChEvV[W
 ******************************************************************************/
LRESULT CALLBACK WndProc( HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam )
{
	switch( msg )
	{
	case WM_KEYDOWN:
		switch( wParam )
		{
		case VK_F2:																//!< F2L[
			if( g_SDL.m_hWnd != NULL )
			{
				switch( g_eDisp )
				{
				case enumDisplay_640x480:										//!< 640x480 -> 800x600
					{
						g_SDL.m_nWidth	= 800;
						g_SDL.m_nHeight	= 600;
						g_SDL.m_bMode	= TRUE;
						// ʐ؂ւ
						DL::ChangeDisplay( g_SDL );

						int nPosX = ( ::GetSystemMetrics( SM_CXSCREEN ) - g_SDL.m_nWidth ) / 2;
						int nPosY = ( ::GetSystemMetrics( SM_CYSCREEN ) - g_SDL.m_nHeight ) / 2;
						::MoveWindow( g_SDL.m_hWnd, nPosX, nPosY, g_SDL.m_nWidth, g_SDL.m_nHeight, TRUE );

						g_eDisp = enumDisplay_800x600;
					}
					break;
				case enumDisplay_800x600:										//!< 800x600 -> 1024x768
					{
						g_SDL.m_nWidth	= 1024;
						g_SDL.m_nHeight	= 768;
						g_SDL.m_bMode	= TRUE;
						// ʐ؂ւ
						DL::ChangeDisplay( g_SDL );

						int nPosX = ( ::GetSystemMetrics( SM_CXSCREEN ) - g_SDL.m_nWidth ) / 2;
						int nPosY = ( ::GetSystemMetrics( SM_CYSCREEN ) - g_SDL.m_nHeight ) / 2;
						::MoveWindow( g_SDL.m_hWnd, nPosX, nPosY, g_SDL.m_nWidth, g_SDL.m_nHeight, TRUE );

						g_eDisp = enumDisplay_1024x768;
					}
					break;
				case enumDisplay_1024x768:										//!< 1024x768 -> 800x600
					{
						g_SDL.m_nWidth	= ::GetSystemMetrics( SM_CXSCREEN );
						g_SDL.m_nHeight	= ::GetSystemMetrics( SM_CYSCREEN );
						g_SDL.m_bMode	= FALSE;
						// ʐ؂ւ
						DL::ChangeDisplay( g_SDL );

						g_eDisp = enumDisplay_FullScreen;
					}
					break;
				case enumDisplay_FullScreen:									//!< tXN[ -> 640x480
					{
						g_SDL.m_nWidth	= 640;
						g_SDL.m_nHeight	= 480;
						g_SDL.m_bMode	= TRUE;
						// ʐ؂ւ
						DL::ChangeDisplay( g_SDL );

						int nPosX = ( ::GetSystemMetrics( SM_CXSCREEN ) - g_SDL.m_nWidth ) / 2;
						int nPosY = ( ::GetSystemMetrics( SM_CYSCREEN ) - g_SDL.m_nHeight ) / 2;
						::MoveWindow( g_SDL.m_hWnd, nPosX, nPosY, g_SDL.m_nWidth, g_SDL.m_nHeight, TRUE );

						g_eDisp = enumDisplay_640x480;
					}
					break;
				}
			}
			break;
		case VK_ESCAPE:															//!< ESCL[
			::DestroyWindow( hWnd );
			break;
		}
		break;
	case WM_DESTROY:															//!< EChE
		::PostQuitMessage( 0 );													//!< WM_QUIT𑗂
		return ::DefWindowProc( hWnd, msg, wParam, lParam );
	default :
		return ::DefWindowProc( hWnd, msg, wParam, lParam );
	}
	return ::DefWindowProc( hWnd, msg, wParam, lParam );
}

/*******************************************************************************
 *	@fn				int Init( const HINSTANCE& hInst )
 *	@param[in]		hInst			CX^Xnh
 *	@retval			int			
 *	@brief			AvP[V̏
 ******************************************************************************/
int Init( const HINSTANCE& hInst )
{
	// dŇ
	// L̊m
	g_hMutex = ::CreateMutex( NULL, FALSE, APPNAME );
	// Ľ
	if( ::WaitForSingleObject( g_hMutex, 0 ) != WAIT_OBJECT_0 )
	{
		_ASSERT( 0 && "WaitForSingleObject()" );
		::CloseHandle( g_hMutex );
		return EXIT_FAILURE;
	}

	// EChE
	WNDCLASS			wc;														//!< EChENX
	// EChENX̓o^
	wc.style				= CS_HREDRAW | CS_VREDRAW;
	wc.lpfnWndProc			= static_cast<WNDPROC>( WndProc );					//!< bZ[W󂯎EChE֐
	wc.cbClsExtra			= 0;
	wc.cbWndExtra			= 0;
	wc.hInstance			= hInst;
	wc.hIcon				= NULL;												//!< ACRo^
	wc.hCursor				= ::LoadCursor( NULL, IDC_ARROW );					//!< J[\o^
	wc.hbrBackground		= static_cast<HBRUSH>( ::GetStockObject( WHITE_BRUSH ) );
	wc.lpszMenuName			= NULL;												//!< j[̓o^
	wc.lpszClassName		= APPNAME;
	// EChENX̓o^
	if( !::RegisterClass( &wc ) ) return EXIT_FAILURE;

	int nSizeX = APPWIDTH;
	int nSizeY = APPHEIGHT;
	int nPosX = ( ::GetSystemMetrics( SM_CXSCREEN ) - nSizeX ) / 2;;
	int nPosY = ( ::GetSystemMetrics( SM_CYSCREEN ) - nSizeY ) / 2;;
	// EChE쐬
	g_hWnd = ::CreateWindow( APPNAME,											//!< NX
							 APPNAME,											//!< ^Cg
							 WS_POPUP,											//!< X^C( WS_OVERLAPPED | WS_CAPTION | WS_SYSMENU )
							 nPosX,												//!< wW
							 nPosY,												//!< xW
							 nSizeX,											//!< 
							 nSizeY,											//!< 
							 NULL,												//!< eEChẼnh
							 NULL,												//!< j[nh
							 hInst,												//!< CX^Xnh
							 NULL );											//!< lParam

	// EChE̍쐬
	if( !g_hWnd ) return EXIT_FAILURE;
	// EChE̕\Ԃ̐ݒ
	::ShowWindow( g_hWnd, SW_SHOW );
	// EChE̍XV
	::UpdateWindow( g_hWnd );

	return EXIT_SUCCESS;
}

/*******************************************************************************
 *	@fn				int Exit( void )
 *	@retval			int			
 *	@brief			AvP[V̏I
 ******************************************************************************/
int Exit( void )
{
	if( g_hWnd != NULL )
	{
		::DestroyWindow( g_hWnd );
		g_hWnd = NULL;
		::UnregisterClass( APPNAME, NULL );
	}
	if( g_hMutex != NULL ){ ::CloseHandle( g_hMutex ); g_hMutex = NULL; }
	return EXIT_SUCCESS;
}

/*******************************************************************************
 *	@fn				BOOL ProcessEvent( void )
 *	@retval			BOOL			
 *	@brief			Cxg̎s
 ******************************************************************************/
BOOL ProcessEvent( void )
{
	MSG	msg;
	// botLPOOŎgpBɂ̃AvŗDŎgp
	while( ::PeekMessage( &msg, NULL, 0, 0, PM_NOREMOVE ) )
	{
		if( !::GetMessage( &msg, NULL, 0, 0 ) )
			return FALSE;
		::TranslateMessage( &msg );
		::DispatchMessage( &msg );
	}
	return TRUE;
}

/*******************************************************************************
 *	@fn				void Init( void )
 *	@retval			BOOL			TRUE=OK/FALSE=NG
 *	@brief			
 ******************************************************************************/
BOOL Init( void )
{
	// p[^̏
	g_SDL.m_hWnd	= g_hWnd;
	g_SDL.m_nWidth	= APPWIDTH;
	g_SDL.m_nHeight	= APPHEIGHT;
	g_SDL.m_bMode	= TRUE;
	// fobȌ
	g_SDbg.m_bUsed	= TRUE;
	RECT m_DbgRect = { APPWIDTH - 160, 0, APPWIDTH, 160 };
	g_SDbg.m_reRect = m_DbgRect;

	// DirectX Library ̏
	if( !DL::Init( g_SDL, g_SDbg ) ) return FALSE;

	// fobOpIuWFNgǉ
	{
		// y
		int DbgNum = OBJMAX + 0;
		g_SObj[ DbgNum ].m_nID		= DbgNum;
		g_SObj[ DbgNum ].m_eObj		= DL::enumObject_Rect;
		g_SObj[ DbgNum ].m_nPrio	= DbgNum;
		g_SObj[ DbgNum ].m_nMatNum	= -1;
		g_SObj[ DbgNum ].m_eDraw	= DL::enumDraw_On;
		g_SObj[ DbgNum ].m_eState	= DL::enumState_Translucent;

		g_SObj[ DbgNum ].m_pData0	= static_cast<RECT*>( &m_DbgRect );
		int nColor0 = 0xCF000000;
		g_SObj[ DbgNum ].m_pData1	= static_cast<int*>( &nColor0 );
		DL::Add( g_SObj[ DbgNum ] );

		// ̃C
		DbgNum = OBJMAX + 1;
		g_SObj[ DbgNum ].m_nID		= DbgNum;
		g_SObj[ DbgNum ].m_eObj		= DL::enumObject_Rect;
		g_SObj[ DbgNum ].m_nPrio	= DbgNum + 10;
		g_SObj[ DbgNum ].m_nMatNum	= -1;
		g_SObj[ DbgNum ].m_eDraw	= DL::enumDraw_On;
		g_SObj[ DbgNum ].m_eState	= DL::enumState_Translucent;

		RECT rc1;
		rc1.left = m_DbgRect.left + 100;
		rc1.top = 0;
		rc1.right = m_DbgRect.left + 100 + 1;
		rc1.bottom = 16;
		g_SObj[ DbgNum ].m_pData0	= static_cast<RECT*>( &rc1 );
		int nColor1 = 0xCFFF0000;
		g_SObj[ DbgNum ].m_pData1	= static_cast<int*>( &nColor1 );
		DL::Add( g_SObj[ DbgNum ] );

		// vO[^[
		DbgNum = OBJMAX + 2;
		g_SObj[ DbgNum ].m_nID		= DbgNum;
		g_SObj[ DbgNum ].m_eObj		= DL::enumObject_Rect;
		g_SObj[ DbgNum ].m_nPrio	= DbgNum;
		g_SObj[ DbgNum ].m_nMatNum	= -1;
		g_SObj[ DbgNum ].m_eDraw	= DL::enumDraw_On;
		g_SObj[ DbgNum ].m_eState	= DL::enumState_Normal;

		RECT rc2;
		rc2.left = rc2.top = rc2.right = 0; rc2.bottom = 16;
		g_SObj[ DbgNum ].m_pData0	= static_cast<RECT*>( &rc2 );
		int nColor2 = 0xCF00FF00;
		g_SObj[ DbgNum ].m_pData1	= static_cast<int*>( &nColor2 );
		int n = DL::Add( g_SObj[ DbgNum ] );

		// Cu[^[
		DbgNum = OBJMAX + 3;
		g_SObj[ DbgNum ].m_nID		= DbgNum;
		g_SObj[ DbgNum ].m_eObj		= DL::enumObject_Rect;
		g_SObj[ DbgNum ].m_nPrio	= DbgNum;
		g_SObj[ DbgNum ].m_nMatNum	= -1;
		g_SObj[ DbgNum ].m_eDraw	= DL::enumDraw_On;
		g_SObj[ DbgNum ].m_eState	= DL::enumState_Translucent;

		rc2.left = rc2.top = rc2.right = 0; rc2.bottom = 16;
		g_SObj[ DbgNum ].m_pData0	= static_cast<RECT*>( &rc2 );
		int nColor3 = 0xCF0000FF;
		g_SObj[ DbgNum ].m_pData1	= static_cast<int*>( &nColor3 );
		n = DL::Add( g_SObj[ DbgNum ] );

		// fޓo^
		g_SDebugFont.m_nID		= 1;
		g_SDebugFont.m_eMat		= DL::enumMaterial_Font;
		g_SDebugFont.m_szName	= "lr SVbN";
		g_SDebugFont.m_nHeight	= 16;
		int nFontNum = DL::Load( g_SDebugFont );

		// \p
		for( int i = 0; i < STRMAX; i++ )
		{
			DbgNum = OBJMAX + METERMAX + i;

			g_SObj[ DbgNum ].m_nID		= DbgNum;
			g_SObj[ DbgNum ].m_eObj		= DL::enumObject_Text;
			g_SObj[ DbgNum ].m_nPrio	= DbgNum;
			g_SObj[ DbgNum ].m_nMatNum	= nFontNum;
			g_SObj[ DbgNum ].m_eDraw	= DL::enumDraw_Off;
			g_SObj[ DbgNum ].m_eState	= DL::enumState_Null;

			rc2 = m_DbgRect;
			rc2.top = 16 + 8 + ( i + 0 ) * 16;
			rc2.bottom = 16 + 8 + ( i + 1 ) * 16;

			g_SObj[ DbgNum ].m_pData0	= static_cast<RECT*>( &rc2 );
			int nColor2 = 0xFFFFFFFF;
			g_SObj[ DbgNum ].m_pData1	= static_cast<int*>( &nColor2 );
			LPSTR lpStr = "";
			g_SObj[ DbgNum ].m_pData2	= static_cast<LPSTR*>( &lpStr );

			n = DL::Add( g_SObj[ DbgNum ] );
		}
	}

	// ^C}[
	g_dwTimer[ 0 ] = g_dwTimer[ 1 ] = ::timeGetTime();

	return TRUE;
}

/*******************************************************************************
 *	@fn				void Proc( void )
 *	@retval			none						Ȃ
 *	@brief			vO
 ******************************************************************************/
void Proc( void )
{
	DL::Clear();
	DL::Measurement();

	DL::CDLGraph* m_CGraph = static_cast<DL::CDLGraph*>( DL::GetGraphics() );

	// \
	{
		if( g_nFrameCnt > 0 )
		{
			float fFps = g_fMeter[ 0 ] + g_fMeter[ 1 ];

			// vŏl
			int DbgNum = OBJMAX + METERMAX + 0;
			DL::D3DOBJECT* m_pD3DObj = m_CGraph->GetObject( g_SObj[ DbgNum ].m_nID );
			m_pD3DObj->m_eDraw = DL::enumDraw_On;

			if( fFps < g_fMinFps ) g_fMinFps = fFps;

			DL::D3DTEXT* pText = static_cast<DL::D3DTEXT*>( m_pD3DObj->m_pObj );
			::sprintf_s( g_cMinFps, 256, "Min %.1f fps", g_fMinFps );
			pText->m_szStr = g_cMinFps;

			// vől
			DbgNum = OBJMAX + METERMAX + 1;
			m_pD3DObj = m_CGraph->GetObject( g_SObj[ DbgNum ].m_nID );
			m_pD3DObj->m_eDraw = DL::enumDraw_On;

			if( g_fMaxFps < fFps ) g_fMaxFps = fFps;

			pText = static_cast<DL::D3DTEXT*>( m_pD3DObj->m_pObj );
			::sprintf_s( g_cMaxFps, 256, "Max %.1f fps", g_fMaxFps );
			pText->m_szStr = g_cMaxFps;

			// vϒl
			DbgNum = OBJMAX + METERMAX + 2;
			m_pD3DObj = m_CGraph->GetObject( g_SObj[ DbgNum ].m_nID );
			m_pD3DObj->m_eDraw = DL::enumDraw_On;

			g_fAveFps = ( ( g_fAveFps * ( g_nFrameCnt - 1 ) ) + fFps ) / g_nFrameCnt;

			pText = static_cast<DL::D3DTEXT*>( m_pD3DObj->m_pObj );
			::sprintf_s( g_cAveFps, 256, "Ave %.3f fps", g_fAveFps );
			pText->m_szStr = g_cAveFps;
		}
		g_nFrameCnt++;
	}

	g_fMeter[ 0 ] = DL::Measurement();
}

/*******************************************************************************
 *	@fn				void Library( void )
 *	@retval			none						Ȃ
 *	@brief			Cu
 ******************************************************************************/
void Library( void )
{
	DL::Measurement();
	DL::Exec();
	g_fMeter[ 1 ] = DL::Measurement();

	// [^[\
	// OvO̎s
	// PCu̎s
	// v@̊֌WA`悪P[vɂ

	DL::CDLGraph* m_CGraph = static_cast<DL::CDLGraph*>( DL::GetGraphics() );

	float fTimer1 = 0.0f;
	float fTimer2 = 0.0f;
	float fTimer3 = 0.0f;
	// vO[^[
	{
		DL::D3DOBJECT* m_pD3DObj = m_CGraph->GetObject( g_SObj[ OBJMAX + 2 ].m_nID );
		DL::D3DDATA* pData = static_cast<DL::D3DDATA*>( m_pD3DObj->m_pObj );

		DL::D3DVERTEX* v0 = static_cast<DL::D3DVERTEX*>( &pData->m_pData[ 0 ] );
		DL::D3DVERTEX* v1 = static_cast<DL::D3DVERTEX*>( &pData->m_pData[ 1 ] );
		DL::D3DVERTEX* v2 = static_cast<DL::D3DVERTEX*>( &pData->m_pData[ 2 ] );
		DL::D3DVERTEX* v3 = static_cast<DL::D3DVERTEX*>( &pData->m_pData[ 3 ] );

		fTimer1 = ( g_fMeter[ 0 ] / FRAMERATE ) * 100.0f;

		v0->x = static_cast<float>( g_SDbg.m_reRect.left + 0 );
		v1->x = static_cast<float>( g_SDbg.m_reRect.left + fTimer1 );
		v2->x = static_cast<float>( g_SDbg.m_reRect.left + fTimer1 );
		v3->x = static_cast<float>( g_SDbg.m_reRect.left + 0 );
	}
	// Cu[^[
	{
		DL::D3DOBJECT* m_pD3DObj = m_CGraph->GetObject( g_SObj[ OBJMAX + 3 ].m_nID );
		DL::D3DDATA* pData = static_cast<DL::D3DDATA*>( m_pD3DObj->m_pObj );

		DL::D3DVERTEX* v0 = static_cast<DL::D3DVERTEX*>( &pData->m_pData[ 0 ] );
		DL::D3DVERTEX* v1 = static_cast<DL::D3DVERTEX*>( &pData->m_pData[ 1 ] );
		DL::D3DVERTEX* v2 = static_cast<DL::D3DVERTEX*>( &pData->m_pData[ 2 ] );
		DL::D3DVERTEX* v3 = static_cast<DL::D3DVERTEX*>( &pData->m_pData[ 3 ] );

		fTimer2 = ( g_fMeter[ 1 ] / FRAMERATE ) * 100.0f + fTimer1;

		v0->x = static_cast<float>( g_SDbg.m_reRect.left + fTimer1 );
		v1->x = static_cast<float>( g_SDbg.m_reRect.left + fTimer2 );
		v2->x = static_cast<float>( g_SDbg.m_reRect.left + fTimer2 );
		v3->x = static_cast<float>( g_SDbg.m_reRect.left + fTimer1 );
	}
}

/*******************************************************************************
 *	@fn				void Sync( void )
 *	@retval			none						Ȃ
 *	@brief			
 ******************************************************************************/
void Sync( void )
{
	// v
	while( 1 )
	{
		g_dwTimer[ 0 ] = ::timeGetTime();
		if( ( g_dwTimer[ 0 ] - g_dwTimer[ 1 ] ) >= FRAMERATE )
		{
			g_fDiffTime += static_cast<float>( ( g_dwTimer[ 0 ] - g_dwTimer[ 1 ] ) ) - FRAMERATE;
			DWORD dwDiff = static_cast<DWORD>( g_fDiffTime );
			g_fDiffTime -= dwDiff;
			g_dwTimer[ 1 ] = g_dwTimer[ 0 ] - dwDiff;
			break;
		}
		// 1ms ҂
		::Sleep( 1 );
	}
}

/*******************************************************************************
 *	@fn				void End( void )
 *	@retval			none						Ȃ
 *	@brief			I
 ******************************************************************************/
void End( void )
{
	// IuWFNg폜
	for( int i = OBJMAX; i < OBJMAX + METERMAX + STRMAX; i++ )
		DL::Del( g_SObj[ i ] );

	// 
	DL::Remove( g_SDebugFont );
}

/*******************************************************************************
 *	@fn				int WINAPI WinMain( HINSTANCE hInstance,
 *									    HINSTANCE hPrevInstance,
 *										LPSTR lpCmdLine,
 *										int nCmdShow )
 *	@param[in]		hInstance		CX^Xnh
 *	@param[in]		hPrevInstance	CX^Xnh
 *	@param[in]		lpCmdLine		
 *	@param[in]		nCmdShow		
 *	@retval			LRESULT			
 *	@brief			vON
 ******************************************************************************/
int WINAPI WinMain( HINSTANCE hInstance,
				    HINSTANCE hPrevInstance,
					LPSTR lpCmdLine,
					int nCmdShow )
{
	// AvP[V̏
	if( Init( hInstance ) == EXIT_FAILURE ) return EXIT_FAILURE;

	if( !Init() ) goto ERR_EXIT;

	// [v
	do
	{
		Proc();			// vOs
		Library();		// Cus
		Sync();			// s
	} while( ProcessEvent() );

	End();
	::CoUninitialize();

ERR_EXIT:
	// DirectX Library ̏I
	DL::Exit();
	// AvP[V̏I
	Exit();

	return EXIT_SUCCESS;
}
